;; emacs-project.el --- project for Emacs C source code  -*- lexical-binding: t -*-

(require 'project)
(require 'uniquify-files)

(cl-defstruct (emacs-project)
  root
  )

(defun emacs-project-try (dir)
  "For 'project-find-functions'."
  (when (string-match "emacs" dir)
    (make-emacs-project :root (locate-dominating-file dir "autogen.sh"))))

(cl-defmethod project-library-roots ((prj emacs-project))
  nil)

(cl-defmethod project-roots ((prj emacs-project))
  (list (emacs-project-root prj)))

(defun emacs-project-ignore-dir (dir)
  "Return non-nil if 'dir' should be ignored in file-completion-table."
  (string-match dir ".*\\.git.*"))

(cl-defmethod project-file-completion-table ((prj emacs-project) dirs)
  (let ((iter (make-path-iterator
	       :user-path-non-recursive nil
	       :user-path-recursive (or dirs (list root))
	       :ignore-function #'emacs-project-ignore-dir)))
    (apply-partially #'uniq-file-completion-table iter)
    ))

(add-to-list 'project-find-functions #'emacs-project-try)

(provide 'emacs-project)
;; end of file
